<?php
/**
 * Tips:純字串時才使用單引號
 */
ini_set("memory_limit","512M"); //php網頁可使用記憶體量
require_once("config.php"); //定義DB相關資料
function DBLink()
{
	global $link;
	#連結資料庫
	$link = mysql_pconnect(DB::$DB_HOST, DB::$DB_USER, DB::$DB_PASSWD);
	mysql_query("SET NAMES 'UTF8'");
	return $link;
}

class GetData
{
	
	/**
	 *	行車路徑GPS座標
	 */
	function getDevGPSInfo($str)
	{
		global $link;
		if (!$link){
			$link = DBLink();
		}
		
		$arr = explode(",",$str);
		$thisDate = $arr[0];
		$stationId = $arr[1];
		
		$query = "SELECT 
								date_time,gps_data
							FROM 
								".DB::$DB_NAME.".".DB::$TABLE_DATA_COMM."
							WHERE
								station_id = '".$stationId."'
							AND 
								date_time >= '".$thisDate." 00:00:00'
							AND
								date_time <= '".$thisDate." 23:59:59'
							ORDER BY date_time";
		$result = mysql_query($query, $link);
		if ($result) {$totalnum = mysql_num_rows($result) ;}
		
		$gpsData = "";
		$i = 0;
		$GPSlat = Array();
		$GPSlng = Array();
		$recordTime = Array();
		$absString = Array();
		while($row = mysql_fetch_object($result)) 
		{
			$gps = $row->gps_data;
			$gpsArray = explode(",",$gps);
			if ($gpsArray[2] == "A") {
				$lat = DMStoDEC($gpsArray[3],'latitude');
				$lng = DMStoDEC($gpsArray[5],'longitude');
				$GPSlat[$i] = $lat;
				$GPSlng[$i] = $lng;
				$i++;
			}else{
				//GPS=V
			}
		}
		$numGps = count($GPSlat);
		for ($i = 0;$i < $numGps;$i++)
		{
			if ($gpsData == "") {
				$gpsData = $GPSlat[$i].",".$GPSlng[$i];
			}else {
				$gpsData .= ";".$GPSlat[$i].",".$GPSlng[$i];
			}
		}
		return $gpsData;
	}
	
	//讀取最後一筆資料 history.php
	function getLastRecord($thisSelectId)
	{
		global $link;
		if (!$link){
			$link = DBLink();
		}
		
		$optVal = "";
		$query = "SELECT 
								station_id,gps_data,io_data,date_time
							FROM 
								".DB::$DB_NAME.".".DB::$TABLE_LAST_RECORD." 
							WHERE
								station_id = '".$thisSelectId."' ";
		$result = mysql_query($query, $link);
		while($row = mysql_fetch_object($result)) 
		{
			$optVal = $row->station_id."_".$row->gps_data."_".$row->io_data."_".$row->date_time;
		}	
		return $optVal;
	}

}

/* 將big5轉成utf-8 */
function big52utf8($big5str) 
{
	$blen = strlen($big5str);
	$utf8str = "";
	for ($i=0; $i<$blen; $i++) 
	{
		$sbit = ord(substr($big5str, $i, 1));
		if ($sbit < 129){
			$utf8str.=substr($big5str,$i,1);
		}elseif ($sbit > 128 && $sbit < 255) {
			$new_word = iconv("big5", "UTF-8", substr($big5str,$i,2));
			$utf8str.=($new_word=="")?" ":$new_word;
			$i++;
		}
	}
	return $utf8str;
}

/* GPS資料轉緯度與經度座標 */
function DMStoDEC($dms, $longlat)
{
	if($longlat == 'latitude'){
		$deg = substr($dms, 0, 2);
		$min = substr($dms, 2, 2);
		$sec = substr($dms, 5, 4);
		//flat_deg = gdeg * 1.0 + (gmin * 60 + gsec / 10000.0 * 60) / 3600.0;
	}
	if($longlat == 'longitude'){
		$deg = substr($dms, 0, 3);
		$min = substr($dms, 3, 2);
		$sec = substr($dms, 6, 4);
	}
	return $deg * 1.0 + ($min * 60 + $sec / 10000.0 * 60) / 3600.0;
}   

/**
 *	計算GPS座標兩點距離 經度longitude , 緯度latitude
 *	採用Vincenty公式計算，參考(http://www.movable-type.co.uk/scripts/latlong-vincenty.html)
 *	較複雜計算，但與Google Maps計算出的距離(公尺基準)較為接近
 *	Input:	座標1(經度,緯度),座標2(經度,緯度)
 *	Output:	兩座標距離(公尺)
 */
function bwtDistance($lat1, $long1, $lat2, $long2) 
{
    $a = 6378137;
    $b = 6356752.314245;
    $f = 1/298.257223563;
    $L = deg2rad($long2 - $long1);
    $U1 = atan((1 - $f) * tan(deg2rad($lat1)));
    $U2 = atan((1 - $f) * tan(deg2rad($lat2)));
    $sinU1 = sin($U1);
    $cosU1 = cos($U1);
    $sinU2 = sin($U2);
    $cosU2 = cos($U2);
    $lambda = $L;
    $iterLimit = 100;
    do {
    	$sinLambda = sin($lambda);
    	$cosLambda = cos($lambda);
    	$sinSigma = sqrt(($cosU2 * $sinLambda) * ($cosU2 * $sinLambda) + ($cosU1 * $sinU2 - $sinU1 * $cosU2 * $cosLambda) * ($cosU1 * $sinU2 - $sinU1 * $cosU2 * $cosLambda));
    	if( $sinSigma == 0 ) {
    		return 0;
    	}
    	$cosSigma = $sinU1 * $sinU2 + $cosU1 * $cosU2 * $cosLambda;
    	$sigma = atan2($sinSigma, $cosSigma);
    	$sinAlpha = $cosU1 * $cosU2 * $sinLambda / $sinSigma;
    	$cosSqAlpha = 1 - $sinAlpha * $sinAlpha;
    	if( $cosSqAlpha == 0 ) {
    		$cos2SigmaM = 0;
    	} else {
    		$cos2SigmaM = $cosSigma - 2 * $sinU1 * $sinU2 / $cosSqAlpha;
    	}
    	$C = $f / 16 * $cosSqAlpha * (4 + $f * (4 - 3 * $cosSqAlpha));
    	$lambdaP = $lambda;
    	$lambda = $L + (1 - $C) * $f * $sinAlpha * ($sigma + $C * $sinSigma * ($cos2SigmaM + $C * $cosSigma * (-1 + 2 * $cos2SigmaM * $cos2SigmaM)));
    } while(abs($lambda - $lambdaP) > 0.000000000001 && --$iterLimit > 0);
    if( $iterLimit == 0 ) {
    	return 0;
    }
    $uSq = $cosSqAlpha * ($a * $a - $b * $b) / ($b * $b);
    $A = 1 + $uSq / 16384 * (4096 + $uSq * (-768 + $uSq * (320 - 175 * $uSq)));
    $B = $uSq / 1024 * (256 + $uSq * (-128 + $uSq * (74 - 47 * $uSq)));
    $deltaSigma = $B * $sinSigma * ($cos2SigmaM + $B / 4 * ($cosSigma * (-1 + 2 * $cos2SigmaM * $cos2SigmaM) - $B / 6 * $cos2SigmaM * (-3 + 4 * $sinSigma * $sinSigma) * (-3 + 4 * $cos2SigmaM * $cos2SigmaM)));
    
    //四捨五入返回整數(公尺)
    return round($b * $A * ($sigma - $deltaSigma));
}

function Sec2Time($time)
{ 
	if(is_numeric($time)){ 
		$value = array( 
			"years" => 0, "days" => 0, "hours" => 0, 
			"minutes" => 0, "seconds" => 0, 
		); 
		if($time >= 31556926){ 
			$value["years"] = floor($time/31556926); 
			$time = ($time%31556926); 
		} 
		if($time >= 86400){ 
			$value["days"] = floor($time/86400); 
			$time = ($time%86400); 
		} 
		if($time >= 3600){ 
			$value["hours"] = floor($time/3600); 
			$time = ($time%3600); 
		} 
		if($time >= 60){ 
			$value["minutes"] = floor($time/60); 
			$time = ($time%60); 
		} 
		$value["seconds"] = floor($time); 
		return (array) $value; 
	}else{ 
		return (bool) FALSE; 
	}
}

function matchColor($i,$gpsNums) 
{
	(int)$colorNum = floor($gpsNums/6); //區別座標顏色判斷
	//echo $i."-".$colorNum."-".$gpsNums."-<br>";
	//Line1 Color:紅 #FF0000
	if ($i < $colorNum)
	{
		return "FF0000";
	}
	//Line2 Color:橙 #FF8C00
	if (($i > $colorNum) && ($i < ($colorNum*2))) 
	{
		return "FF8C00";
	}
	//Line3 Color:黃 #FFFF00(太淡)->E6D933
	/**
	if (($i > ($colorNum*2)) && ($i < ($colorNum*3))) 
	{
		return "E6D933";
	}
	*/
	//Line3 Color:綠 #32CD32 
	if (($i > ($colorNum*2)) && ($i < ($colorNum*3))) 
	{
		return "32CD32";
	}
	//Line4 Color:藍 #1E90FF 
	if (($i > ($colorNum*3)) && ($i < ($colorNum*4))) 
	{
		return "1E90FF";
	}
	//Line5 Color:靛 #4B0082 
	if (($i > ($colorNum*4)) && ($i < ($colorNum*5))) 
	{
		return "4B0082";
	}
	//Line6 Color:紫 #8B00FF 
	if (($i > ($colorNum*5)) && ($i < $gpsNums)) 
	{
		return "8B00FF";
	}
}

?>